// DivideDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "Divide.h"
#include "DivideDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CDivideDlg Ի




CDivideDlg::CDivideDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDivideDlg::IDD, pParent)
	, i_strDestFile(_T(""))
	, i_dw64TotalSize(0)
	, i_dw64BlockSize(0)
	, i_dw64Blocks(0)
	, i_strIndexFileName(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDivideDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_E_DEST_FILE, i_strDestFile);
	DDX_Text(pDX, IDC_E_TOTAL_SIZE, i_dw64TotalSize);
	DDX_Text(pDX, IDC_E_BLOCK_SIZE, i_dw64BlockSize);
	DDX_Text(pDX, IDC_E_BLOCKS, i_dw64Blocks);
	DDX_Text(pDX, IDC_E_INDEX_FILE_NAME, i_strIndexFileName);
}

BEGIN_MESSAGE_MAP(CDivideDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_SELECT_DEST, &CDivideDlg::OnBnClickedBtnSelectDest)
	ON_EN_CHANGE(IDC_E_BLOCK_SIZE, &CDivideDlg::OnEnChangeEBlockSize)
	ON_BN_CLICKED(IDC_BTN_DIVIDE, &CDivideDlg::OnBnClickedBtnDivide)
	ON_BN_CLICKED(IDC_BTN_REVERT, &CDivideDlg::OnBnClickedBtnRevert)
	ON_BN_CLICKED(IDC_BTN_SELECT_INDEX, &CDivideDlg::OnBnClickedBtnSelectIndex)
END_MESSAGE_MAP()


// CDivideDlg Ϣ

BOOL CDivideDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	// TODO: ڴӶĳʼ

	return TRUE;  // ǽõؼ򷵻 TRUE
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CDivideDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CDivideDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// ºΪԶ庯

// ָļ
BOOL CDivideDlg::DivideFile(PFILE_ITEM_INFO pItem)
{
	this->DeleteAllPartFiles ( pItem->strFileName );

	// Ϣļ
	HANDLE hFile = CreateFile ( pItem->strFileName + L".INDEX", GENERIC_READ | GENERIC_WRITE, \
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL );

	if ( hFile == INVALID_HANDLE_VALUE )
		return FALSE;
	else
	{
		DWORD dwWriteByte;
		WriteFile( hFile, &(pItem->dw64FileSize), sizeof(DWORD64), &dwWriteByte, NULL );
		WriteFile( hFile, &(pItem->dw64PartSize), sizeof(DWORD64), &dwWriteByte, NULL );
		WriteFile( hFile, &(pItem->dw64PartNum), sizeof(DWORD64), &dwWriteByte, NULL );
		CloseHandle( hFile );
	}

	// Ŀļ
	hFile = CreateFile ( pItem->strFileName, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, \
		NULL, OPEN_EXISTING, 0, NULL );

	// ļڴӳں˶
	HANDLE hMapFile = CreateFileMapping ( hFile, NULL, PAGE_READONLY, 0, 0, NULL );
	
	// ֿļ
	CString strChild;

	// dwCurAddr ǰļƫƵַ, dwCurPart ǰС
	DWORD64 dw64CurAddr = 0, dw64CurPart = 0;
	LPVOID lpMapAddr = 0;

	// ֿѭӳļ
	for( UINT i = 1; i <= pItem->dw64PartNum; ++i )
	{
		dw64CurPart = pItem->dw64FileSize - dw64CurAddr;
		if( dw64CurPart > pItem->dw64PartSize )
			dw64CurPart = pItem->dw64PartSize;
		
		// ļļ
		strChild.Format( L"%s.PART_%d", pItem->strFileName, i );
		DeleteFile( strChild );

		// ָĿֳ̫Сӳ
		if( dw64CurPart > SMALL_BLOCK_SIZE )
		{
			// ļ
			HANDLE hCFile = CreateFile( strChild, GENERIC_READ | GENERIC_WRITE, \
				FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL );
			// ļӳں˶
			HANDLE hCMapFile = CreateFileMapping ( hCFile, NULL, PAGE_READWRITE, (dw64CurPart / G4), \
				(dw64CurPart % G4), NULL );
			
			// dw64PartTemp ѭ
			DWORD64 dw64PartTemp = dw64CurPart + SMALL_BLOCK_SIZE;
			// dw64AddrTemp СļڴļеƫƵַ
			DWORD64 dw64AddrTemp = dw64CurAddr;
			
			while( dw64PartTemp > SMALL_BLOCK_SIZE )
			{
				// СС
				DWORD dwPartTemp = ( (dw64PartTemp - SMALL_BLOCK_SIZE) >= SMALL_BLOCK_SIZE) ? \
										SMALL_BLOCK_SIZE : (dw64PartTemp % SMALL_BLOCK_SIZE);

				// ҪָԴļӳΪС
				lpMapAddr = MapViewOfFile ( hMapFile, FILE_MAP_READ, (dw64AddrTemp / G4), (dw64AddrTemp % G4), \
					dwPartTemp );
				if( NULL == lpMapAddr )
				{
					CString strErr;
					strErr.Format ( L"lpMapAddr Error Code:%d", GetLastError() );
					MessageBox ( strErr );
					return FALSE;
				}
				// ļָΪСӳ
				LPVOID lpCMapAddr = MapViewOfFile ( hCMapFile, FILE_MAP_WRITE, ((dw64AddrTemp - (i-1)*(pItem->dw64PartSize))/G4),\
					((dw64AddrTemp - (i-1)*(pItem->dw64PartSize))%G4), dwPartTemp );
				if( NULL == lpCMapAddr )
				{
					CString strErr;
					strErr.Format ( L"lpCMapAddr Error Code:%d", GetLastError() );
					MessageBox ( strErr );
					return FALSE;
				}
				// 
				dw64AddrTemp += dwPartTemp;
				// ѭ
				dw64PartTemp -= SMALL_BLOCK_SIZE;

				memcpy( lpCMapAddr, lpMapAddr, dwPartTemp );
				// С
				FlushViewOfFile ( lpCMapAddr, dwPartTemp );
				UnmapViewOfFile ( lpMapAddr );
				UnmapViewOfFile ( lpCMapAddr );
			}

			dw64CurAddr += dw64CurPart;
			
			CloseHandle ( hCFile );
			CloseHandle ( hCMapFile );
		}
		else
		{
			// ӳĿ
			lpMapAddr = MapViewOfFile ( hMapFile, FILE_MAP_READ, (dw64CurAddr/G4), (dw64CurAddr%G4), dw64CurPart );
			dw64CurAddr += dw64CurPart;
			if( NULL == lpMapAddr )
			{
				CString strErr;
				strErr.Format ( L"Error Code:%d", GetLastError());
				MessageBox ( strErr );
				return FALSE;
			}

			// ļӳ䵽ڴ
			HANDLE hNewFile = CreateFile ( strChild, GENERIC_READ | GENERIC_WRITE,\
				FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL );

			HANDLE hNewMapFile = CreateFileMapping ( hNewFile, NULL, PAGE_READWRITE, (dw64CurPart / G4),\
				(dw64CurPart % G4), NULL );
			LPVOID lpNewMapAddr = MapViewOfFile ( hNewMapFile, FILE_MAP_WRITE, 0, 0, 0 );
			if( NULL == lpNewMapAddr )
			{
				CString strErr;
				strErr.Format ( L"Error Code:%d", GetLastError());
				MessageBox ( strErr );
				return FALSE;
			}

			// д뵽ļ
			memcpy ( lpNewMapAddr, lpMapAddr, dw64CurPart );
			UnmapViewOfFile ( lpMapAddr );
			UnmapViewOfFile ( lpNewMapAddr );
			CloseHandle ( hNewMapFile );
			CloseHandle ( hNewFile );			
		}
	}

	CloseHandle ( hMapFile );
	CloseHandle ( hFile );

	MessageBox ( L"Divide OK." );
	
	return TRUE;
}

// ɾֿļ
BOOL CDivideDlg::DeleteAllPartFiles(CString strFileName)
{

	return 0;
}
// ԭָļ
BOOL CDivideDlg::RevertFile(PFILE_ITEM_INFO pItem)
{

	// Ŀļ
	HANDLE hFile = CreateFile ( pItem->strFileName, GENERIC_READ | GENERIC_WRITE, \
		FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, 0, NULL );

	// ļڴӳں˶
	HANDLE hMapFile = CreateFileMapping ( hFile, NULL, PAGE_READWRITE, pItem->dw64FileSize / G4, pItem->dw64FileSize % G4, NULL );

	CString strChild;
	DWORD64 dw64CurAddr = 0, dw64CurPart = 0;
	LPVOID lpMapAddr = 0;

	
	// ֿѭӳļ
	for( UINT i = 1; i <= pItem->dw64PartNum; ++i )
	{
		dw64CurPart = pItem->dw64FileSize - dw64CurAddr;
		if( dw64CurPart > pItem->dw64PartSize )
			dw64CurPart = pItem->dw64PartSize;
		
		// ļļ
		strChild.Format( L"%s.PART_%d", pItem->strFileName, i );

		if( pItem->dw64PartSize > SMALL_BLOCK_SIZE )
		{
			// 򿪷ֿļ
			HANDLE hCFile = CreateFile ( strChild, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, \
				NULL, OPEN_EXISTING, 0, NULL );
			// ļӳں˶
			HANDLE hCMapFile = CreateFileMapping ( hCFile, NULL, PAGE_READONLY, 0, 0, NULL );

			DWORD64 dw64PartTemp = dw64CurPart + SMALL_BLOCK_SIZE;
			DWORD64 dw64AddrTemp = 0;
			
			while( dw64PartTemp > SMALL_BLOCK_SIZE )
			{
				// СС
				DWORD dwPartTemp = ((dw64PartTemp - SMALL_BLOCK_SIZE) >= SMALL_BLOCK_SIZE ) ? \
					SMALL_BLOCK_SIZE : ( dw64PartTemp % SMALL_BLOCK_SIZE );
				// ӳӿС鵽ڴ
				LPVOID lpCMapAddr = MapViewOfFile ( hCMapFile, FILE_MAP_READ, dw64AddrTemp / G4,\
					dw64AddrTemp % G4, dwPartTemp );

				if( NULL == lpCMapAddr )
				{
					CString strErr;
					strErr.Format ( L"Error Code:%d", GetLastError());
					MessageBox ( strErr );
					return FALSE;
				}
				dw64AddrTemp += dwPartTemp;

				// ӳҪԭļС鵽ڴ
				lpMapAddr = MapViewOfFile ( hMapFile, FILE_MAP_WRITE, dw64CurAddr / G4, dw64CurAddr % G4, dwPartTemp );
				if( NULL == lpMapAddr )
				{
					CString strErr;
					strErr.Format ( L"Error Code:%d", GetLastError());
					MessageBox ( strErr );
					return FALSE;				
				}
				dw64CurAddr += dwPartTemp ;

				dw64PartTemp -= SMALL_BLOCK_SIZE;
				
				// ӿСݸƵҪԭԴļС
				memcpy ( lpMapAddr, lpCMapAddr, dwPartTemp );

				// ݵļ
				FlushViewOfFile ( lpMapAddr, dwPartTemp );
				UnmapViewOfFile ( lpCMapAddr );
				UnmapViewOfFile ( lpMapAddr );
			}

			CloseHandle ( hCFile );
			CloseHandle ( hCMapFile );
		}
		else
		{
			lpMapAddr = MapViewOfFile ( hMapFile, FILE_MAP_WRITE, 0, dw64CurAddr, dw64CurPart );
			dw64CurAddr += dw64CurPart;
			
			// ļڴӳ
			HANDLE hCFile = CreateFile ( strChild, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, \
				NULL, OPEN_EXISTING, 0, NULL );
			HANDLE hCMapFile = CreateFileMapping ( hCFile, NULL, PAGE_READONLY, 0, 0, NULL );
			LPVOID lpCMapAddr = MapViewOfFile ( hCMapFile, FILE_MAP_READ, 0, 0, 0 );

			// ļݸƵԭԴļ
			memcpy ( lpMapAddr, lpCMapAddr, dw64CurPart );

			//ݵļ
			FlushViewOfFile ( lpMapAddr, dw64CurPart );
			UnmapViewOfFile ( lpMapAddr );
			UnmapViewOfFile ( lpCMapAddr );

			CloseHandle ( hCFile );
			CloseHandle ( hCMapFile );
		}
	}

	CloseHandle ( hMapFile );
	CloseHandle ( hFile );

	// ɾļ
	this->DeleteAllPartFiles ( pItem->strFileName );

	MessageBox ( L"Revert OK." );

	return TRUE;
}

// ʼļṹϢ
BOOL CDivideDlg::GetFileInfo( CString strFileName, PFILE_ITEM_INFO pItem )
{
	HANDLE hFile = CreateFile ( strFileName, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE,\
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) ;
	if ( hFile == INVALID_HANDLE_VALUE )
		return GetLastError() ;
	
	pItem->strFileName = strFileName ;

	// ļС
	LARGE_INTEGER lInteger;
	GetFileSizeEx ( hFile, &lInteger );
	pItem->dw64FileSize = G4*lInteger.u.HighPart + lInteger.u.LowPart;
	pItem->dw64PartSize = 1024*1024;
	this->GetBlocksNum ( pItem );

	CloseHandle ( hFile ) ;

	return TRUE;
}

// ͨļȡҪԭļϢ
BOOL CDivideDlg::GetIndexInfo( CString strIndexName, PFILE_ITEM_INFO pItem )
{
	HANDLE hFile = CreateFile( strIndexName, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, \
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	if( hFile == INVALID_HANDLE_VALUE )
		return FALSE;

	DWORD dwReaded;
	ReadFile ( hFile, &pItem->dw64FileSize, sizeof(DWORD64), &dwReaded, NULL );
	ReadFile ( hFile, &pItem->dw64PartSize, sizeof(DWORD64), &dwReaded, NULL );
	ReadFile ( hFile, &pItem->dw64PartNum, sizeof(DWORD64), &dwReaded, NULL );

	pItem->strFileName = strIndexName.Mid( 0, strIndexName.GetLength() - 6 );
	return TRUE;
}

// ÿ
BOOL CDivideDlg::GetBlocksNum( PFILE_ITEM_INFO pItem )
{
	if(pItem->dw64PartSize < M1 )
	{
		MessageBox ( L"The limit block size is 1M." );
		pItem->dw64PartSize = M1;
	}
	pItem->dw64PartNum = pItem->dw64FileSize / pItem->dw64PartSize;
	if( pItem->dw64FileSize % pItem->dw64PartSize != 0 )
		pItem->dw64PartNum += 1;
	
	return TRUE;
}

// ºΪϢӦ

// ޸ķָļСʱӦ˺
void CDivideDlg::OnEnChangeEBlockSize()
{
	// TODO:  ÿؼ RICHEDIT ؼ
	// ͸֪ͨд CDialog::OnInitDialog()
	//  CRichEditCtrl().SetEventMask()
	// ͬʱ ENM_CHANGE ־㵽С

	// TODO:  ڴӿؼ֪ͨ

	this->UpdateData( TRUE );

	FILE_ITEM_INFO fItem;
	
	// ޸ļС
	this->GetFileInfo( this->i_strDestFile, &fItem );
	fItem.dw64PartSize = this->i_dw64BlockSize;
	// ޸Ŀ
	this->GetBlocksNum( &fItem );
	this->i_dw64Blocks = fItem.dw64PartNum;
	this->i_dw64BlockSize = fItem.dw64PartSize;

	this->UpdateData ( FALSE );
}

// ָťӦ
void CDivideDlg::OnBnClickedBtnDivide()
{
	// TODO: ڴӿؼ֪ͨ

	FILE_ITEM_INFO fItem;

	this->GetFileInfo ( this->i_strDestFile, &fItem );
	fItem.dw64PartSize = this->i_dw64BlockSize;
	this->GetBlocksNum ( &fItem );

	this->DivideFile ( &fItem );
}

// ԭťӦ
void CDivideDlg::OnBnClickedBtnRevert()
{
	// TODO: ڴӿؼ֪ͨ
	FILE_ITEM_INFO fItem;

	this->GetIndexInfo ( this->i_strIndexFileName, &fItem );
	
	this->RevertFile ( &fItem );

	
}

// ѡԭļťӦ
void CDivideDlg::OnBnClickedBtnSelectIndex()
{
	// TODO: ڴӿؼ֪ͨ

	WCHAR szFilter[] = L"The index of the divided files.(*.index)|*.index||";
	CFileDialog fDlg( TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL );
	if( fDlg.DoModal() == IDOK)
	{
		this->i_strIndexFileName = fDlg.GetPathName();

		this->UpdateData( FALSE );
	}
}

// ѡҪָԴļťӦ
void CDivideDlg::OnBnClickedBtnSelectDest()
{
	// TODO: ڴӿؼ֪ͨ

	CFileDialog fDlg(TRUE);
	if( fDlg.DoModal() == IDOK)
	{
		this->i_strDestFile = fDlg.GetPathName();

		FILE_ITEM_INFO fItem;
		this->GetFileInfo( this->i_strDestFile, &fItem );

		this->i_dw64BlockSize = fItem.dw64PartSize;
		this->i_dw64Blocks = fItem.dw64PartNum;
		this->i_dw64TotalSize = fItem.dw64FileSize;

		this->UpdateData( FALSE );
	}
}